-------------------------------------------------------------- 
--  Subject : List processing, two-way lists
--  Copyright (c) 1999 by A.Baranovsky
--------------------------------------------------------------

  function App( L, var P, Key ) 
    P := [ Key, ==P[ 2 ], << P ]
    P[ 3, 2 ]    == P
    P[ 3, 3, 2 ] == P[ 3 ]
  return P
  
  function Delete( L, var P )
    Q == P[ 2 ]  
    temp << P[ 3 ]
    Destroy( @P )
    P << temp
    P[ 2 ]    == Q 
    P[ 3, 2 ] == P
  return Q
  
  function Show( L )
    writeln( '' )
    P == L
    while not Null( P[ 1 ] ) do
      writeln( P[ 1 ] )
      P == P[ 3 ] 
    end
  return 0

  constant 
    Next = 3
  end

  L := [ *, == L, == L ]                -- Create list L

  App( L, L, 'a' )                      -- Append string 'a' to L
  Show( L )
  App( L, L[ Next ], 'b' )              -- Insert 'b' after 'a'
  Show( L )
  App( L, L, 'c' )                      -- Insert 'c' in the L's head
  Show( L ) 
  Delete( L, L[ Next, Next ] )          -- Delete 'b'
  Show( L )

return
